import processing.serial.*;
import ddf.minim.*; 
import ddf.minim.signals.*; 

import processing.sound.*;

Minim minim; 

// set up multiple
AudioPlayer radio1; 
AudioPlayer radio2; 
SoundFile tapeSound;

int linefeed = 10; // new line ASCII = 10
Serial myPort;

boolean newData = false;
boolean playing = false;
int currentPlay = 0;
int value1 = 0; //this variable will contain the reading
void setup () {
  size(800, 600);
  printArray(Serial.list());
  // change port!
  myPort =  new Serial(this, Serial.list()[11], 9600);
  // here we're saying that we need to buffer until 'NEW LINE'
  myPort.bufferUntil(linefeed);
  myPort.clear();
  // set up multiple streams here
  minim = new Minim(this); 
  radio1 = minim.loadFile("http://ice1.somafm.com/spacestation-128-mp3", 2048);
  radio2 = minim.loadFile("http://ice1.somafm.com/deepspaceone-128-mp3", 2048);
  tapeSound = new SoundFile(this, "tape.wav");
  println("loaded");
}

void draw () 
{ 
  //do something with "value1"

  // print(currentPlay);

  if (newData)
  {
    if (playing)
    {
      // stop all streams
      playStream(0);
    } else 
    {
      // play the current value
      if (value1 == 1)
      {
        playStream(1);
      } else if (value1 == 2)
      {
        playStream(2);
      }
    }
  }

  newData = false;
}

void playStream(int stream)
{
  // set this up to play and stop stream based on stream number with 0 stopping all streams
  if (stream == 0)
  {
    // stop playing stream
    println("Stopping Stream");
    tapeSound.play();
    delay(500);
    radio1.pause();
    radio2.pause();
    playing = false;
  } else if (stream == 1)
  {
    println("Playing Stream 1");
    tapeSound.play();
    delay(500);
    radio1.play();
    playing = true;
  } else if (stream == 2)
  {
    println("Playing Stream 2");
    tapeSound.play();
    delay(500);
    radio2.play();
    playing = true;
  }
}

void serialEvent (Serial myPort) 
{
  // read serial buffer as string
  String myString = myPort.readString();

  // if we have any other bytes than linefeed
  if (myString != null) 
  {
    // trim crap
    myString = trim(myString);
    value1 = int(myString); //make string to integer
    // println(value1);
  }
  newData = true;
  delay(20);
}

void stop()
{
}
